﻿/*
    Lisans (Türkçe Metin)
    MIT Lisansı (MIT)
    Copyright (c) 2018 tubitak-bilgem-yte

    Hiçbir ücret talep edilmeden burada işbu yazılımın bir kopyasını ve belgelendirme 
    dosyalarını (“Yazılım”) elde eden herkese verilen izin; kullanma, kopyalama, 
    değiştirme, birleştirme, yayımlama, dağıtma, alt lisanslama, ve/veya yazılımın 
    kopyalarını satma eylemleri de dahil olmak üzere ve bununla kısıtlama olmaksızın, 
    yazılımın sınırlama olmadan ticaretini yapmak için verilmiş olup, bunları yapmaları 
    için yazılımın sağlandığı kişilere aşağıdakileri yapmak koşuluyla sunulur:

    Yukarıdaki telif hakkı bildirimi ve işbu izin bildirimi yazılımın tüm kopyalarına 
    veya önemli parçalarına eklenmelidir. 

    YAZILIM “HİÇBİR DEĞİŞİKLİK YAPILMADAN” ESASINA BAĞLI OLARAK, TİCARETE ELVERİŞLİLİK, 
    ÖZEL BİR AMACA UYGUNLUK VE İHLAL OLMAMASI DA DAHİL VE BUNUNLA KISITLI OLMAKSIZIN 
    AÇIKÇA  VEYA ÜSTÜ KAPALI OLARAK HİÇBİR TEMİNAT OLMAKSIZIN SUNULMUŞTUR. HİÇBİR KOŞULDA 
    YAZARLAR  VEYA TELİF HAKKI SAHİPLERİ HERHANGİ BİR İDDİAYA, HASARA VEYA DİĞER 
    YÜKÜMLÜLÜKLERE KARŞI, YAZILIMLA VEYA KULLANIMLA VEYA YAZILIMIN BAŞKA BAĞLANTILARIYLA 
    İLGİLİ, BUNLARDAN KAYNAKLANAN VE BUNLARIN SONUCU BİR SÖZLEŞME DAVASI, HAKSIZ FİİL 
    VEYA DİĞER EYLEMLERDEN SORUMLU DEĞİLDİR. 

    License (English)
    The MIT License (MIT)
    Copyright (c) 2018 tubitak-bilgem-yte

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.
*/

using RestSharp;
using RestSharp.Deserializers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using uts_uh.model;

namespace uts_uh
{
    class Program
    {
        /* Gercek sisteme entegre olmak icin utstest yerine utsuygulama yazilmalidir */
        private const string url = "https://utstest.saglik.gov.tr";
        private RestClient client = new RestClient(url);
        /* utstest veya utsuygulama'ya giris yapip Kullanici > Sistem Kullanicisi Tanimlama Islemleri
	     *  menusunden alinan token asagida utsToken olarak ayarlanmalidir */
        private const string systemToken = "";

        static void Main(string[] args)
        {
            var program = new Program();

            /* Asagida su bildirim parametreleri ayarlanmaktadir: urunNumarasi, seriNumarasi, belgeNumarasi, kurumNumarasi
		       Bunlarin yerine uygun degerleri girmelisiniz. */
            // Urun Numarasi, Barkod Numarasi, Urun Karti uzerindeki numara
            string urunNumarasi = "";
            // Urunun seri numarasi
            string seriNumarasi = "";
            // tekil urunun uretim tarihi YYYY-MM-DD seklinde olmalidir. Ornegin 2017-09-13 gibi.
            string uretimTarihi = "";
            // Verme islemine iliskin duzenlenen belge numarasi, ornegin irsaliye numarasi.
            string belgeNumarasi = "";
            // Verme yapilacak kurumun UBB numarasi numarasi
            long kurumNumarasi = -1L;

            program.uretimBildirimiEkle(urunNumarasi, seriNumarasi, uretimTarihi);
            program.vermeBildirimiEkle(urunNumarasi, seriNumarasi, belgeNumarasi, kurumNumarasi);

            System.Console.ReadKey();
        }

        public void uretimBildirimiEkle(string urunNumarasi, string seriNumarasi, string uretimTarihi)
        {
            var request = new RestRequest("UTS/uh/rest/bildirim/uretim/ekle", Method.POST);

            request.AddHeader("Content-type", "application/json; charset=utf-8");            
            request.AddHeader("utsToken", systemToken);
            request.AddJsonBody(
            new
            {
                UNO = urunNumarasi,
                SNO = seriNumarasi,
                URT = uretimTarihi
            });

            IRestResponse response = client.Execute(request);

            var deserializer = new JsonDeserializer();
            Sonuc sonuc = deserializer.Deserialize<Sonuc>(response);

            System.Console.WriteLine("SNC:" + sonuc.SNC);
            System.Console.WriteLine("MET:" + sonuc.MSJ[0].MET);
            System.Console.WriteLine("KOD:" + sonuc.MSJ[0].KOD);
            System.Console.WriteLine("TIP:" + sonuc.MSJ[0].TIP);
        }

        public void vermeBildirimiEkle(string urunNumarasi, string seriNumarasi, string belgeNumarasi, long kurumNumarasi)
        {
            var request = new RestRequest("UTS/uh/rest/bildirim/verme/ekle", Method.POST);

            request.AddHeader("Content-type", "application/json; charset=utf-8");
            request.AddHeader("utsToken", systemToken);

            request.AddJsonBody(
            new
            {
                UNO = urunNumarasi,
                SNO = seriNumarasi,
                BNO = belgeNumarasi,
                KUN = kurumNumarasi
            });

            IRestResponse response = client.Execute(request);

            var deserializer = new JsonDeserializer();
            Sonuc sonuc = deserializer.Deserialize<Sonuc>(response);

            System.Console.WriteLine("SNC:" + sonuc.SNC);
            System.Console.WriteLine("MET:" + sonuc.MSJ[0].MET);
            System.Console.WriteLine("KOD:" + sonuc.MSJ[0].KOD);
            System.Console.WriteLine("TIP:" + sonuc.MSJ[0].TIP);
        }

    }
}
